/////////////////////ACDFSM by Redphoenix///////////////////////////////////////////////
//////main shader
///////////////////////////////////////////////////////////////////////////////////////////////////////////
Texture TargetMap;
float4 vecSkill1; //x = resolution y = correction
sampler2D shadow_map = sampler_state { 
Texture = <TargetMap>;
   AddressU  = clamp;
AddressV  = clamp;

};
float4 mainPS(float4 tex : TEXCOORD0) : COLOR
{  //tex.xy /= tex.w;
   float2 tc = vecSkill1.x * tex;
   float2 fc = frac(tc);
   tc -= fc;
   tex.xy = tc / vecSkill1.x;
   
   float m100 = tex2D(shadow_map,tex + float2(-0.5/vecSkill1.x,-0.5/vecSkill1.x));
   float m010 = tex2D(shadow_map,tex + float2(0.0,-0.5/vecSkill1.x));
   float m001 = tex2D(shadow_map,tex + float2(0.5/vecSkill1.x,-0.5/vecSkill1.x));
   float m200 = tex2D(shadow_map,tex + float2(-0.5/vecSkill1.x,0.0));
   float m020 = tex2D(shadow_map,tex + float2(0.0,0.0));
   float m002 = tex2D(shadow_map,tex + float2(0.5/vecSkill1.x,0.0));
   float m300 = tex2D(shadow_map,tex + float2(-0.5/vecSkill1.x,0.5/vecSkill1.x));
   float m030 = tex2D(shadow_map,tex + float2(0.0,0.5/vecSkill1.x));
   float m003 = tex2D(shadow_map,tex + float2(0.5/vecSkill1.x,0.5/vecSkill1.x));
   
   float3 maxdepth = max(max(float3(m100,m010,m001),float3(m200,m020,m002)),float3(m300,m030,m003));
   float3 mindepth = min(min(float3(m100,m010,m001),float3(m200,m020,m002)),float3(m300,m030,m003));
   float max_d = max(maxdepth.x,max(maxdepth.y,maxdepth.z));
   float min_d = min(mindepth.x,min(mindepth.y,mindepth.z));
   float d0 = (2/3.0) * min_d + (1/3.0) * max_d;
   float d1 = (1/3.0) * min_d + (2/3.0) * max_d;
   float p0 = 0;
   float p1 = 0;
   p0 += dot(float3(m100,m010,m001) <= float3(d0,d0,d0),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   p0 += dot(float3(m200,m020,m002) <= float3(d0,d0,d0),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   p0 += dot(float3(m300,m030,m003) <= float3(d0,d0,d0),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   p1 += dot(float3(m100,m010,m001) <= float3(d1,d1,d1),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   p1 += dot(float3(m200,m020,m002) <= float3(d1,d1,d1),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   p1 += dot(float3(m300,m030,m003) <= float3(d1,d1,d1),float3(1.0/9.0,1.0/9.0,1.0/9.0));
   
   
   
   return float4(m020,p0,p1,m020+vecSkill1.y*smoothstep(min_d,max_d,m020));
   //return tex2D(shadow_map,tex);
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		PixelShader = compile ps_2_a mainPS();
	}
}