/////////////////////ACDFSM by Redphoenix///////////////////////////////////////////////
//////main shader
///////////////////////////////////////////////////////////////////////////////////////////////////////////
Texture TargetMap;
Texture mtlSkin1;
Texture mtlSkin2;
Texture mtlSkin3;
Texture mtlSkin4;
Texture shadow5_bmap;
Texture shadow6_bmap;
Texture shadow7_bmap;
float4 vecSkill1;
sampler2D main_map = sampler_state { Texture = <TargetMap>;
   AddressU  = clamp;
AddressV  = clamp;

 };
sampler2D shadow_map = sampler_state { Texture = <mtlSkin1>;
   AddressU  = clamp;
AddressV  = clamp;

 };
sampler2D shadow2_map = sampler_state { Texture = <mtlSkin2>;
   AddressU  = clamp;
AddressV  = clamp;

 };
sampler2D shadow3_map = sampler_state { Texture = <mtlSkin3>;
   AddressU  = clamp;
AddressV  = clamp;

 };
sampler2D shadow4_map = sampler_state { Texture = <mtlSkin4>;
   AddressU  = clamp;
AddressV  = clamp;

 }; 
sampler2D shadow5_map = sampler_state { Texture = <shadow5_bmap>;
   AddressU  = clamp;
AddressV  = clamp;

 }; 
sampler2D shadow6_map = sampler_state { Texture = <shadow6_bmap>;
   AddressU  = clamp;
AddressV  = clamp;

 };
sampler2D shadow7_map = sampler_state { Texture = <shadow7_bmap>;
   AddressU  = clamp;
AddressV  = clamp;

 }; 
float4 mainPS(float2 tex : TEXCOORD0) : COLOR
{
 
	float4 Color = tex2D(main_map,tex);
	float4 Shadow = tex2D(shadow_map,tex);   	
	float4 Shadow2 = tex2D(shadow2_map,tex);   	
	float4 Shadow3 = tex2D(shadow3_map,tex); 
	float4 Shadow4 = tex2D(shadow4_map,tex); 	
	float4 Shadow5 = tex2D(shadow5_map,tex); 		
	float4 Shadow6 = tex2D(shadow6_map,tex); 			
	float4 Shadow7 = tex2D(shadow6_map,tex); 				
	if(Shadow.a<=0.1)Shadow = 1.0;
	if(Shadow2.a<=0.1)Shadow2 = 1.0;	
	if(Shadow3.a<=0.1)Shadow3 = 1.0;		
	if(Shadow4.a<=0.1)Shadow4 = 1.0;			
	if(Shadow5.a<=0.1)Shadow5 = 1.0;			   
	if(Shadow6.a<=0.1)Shadow6 = 1.0;			      
	if(Shadow7.a<=0.1)Shadow7 = 1.0;			         
   return float4(Color.rgb*((Shadow.rgb+Shadow2.rgb+Shadow3.rgb+Shadow4.rgb+Shadow5.rgb+Shadow6.rgb+Shadow7.rgb)*vecSkill1.x),Color.a);
   
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		PixelShader = compile ps_2_0 mainPS();
	}
}