/////////////////////ACDFSM by Redphoenix///////////////////////////////////////////////
//////Depthshader
///////////////////////////////////////////////////////////////////////////////////////////////////////////
float4x4 matWorldViewProj;

//float4x4 matMtl; 	// Texture projection matrix

Texture entSkin1;
sampler2D main_map = sampler_state { Texture = <entSkin1>;
//MinFilter = None;
//MagFilter = None;
//MipFilter = None;
  AddressU  = wrap;
AddressV  = wrap;

 };
float4 vecSkill1; 
float4 vecSkill5;  

struct depthstr
{
    float4 Position     : POSITION;
    float smdepth   : TEXCOORD0;
    float2 TexCoords    : TEXCOORD1;
};

// Vertex Shader
depthstr depthVS( float4 inPos : POSITION, float2 texcoords : TEXCOORD0)
{
    depthstr Output;
	 Output.Position = mul(inPos,matWorldViewProj); 
    Output.TexCoords = texcoords;
    Output.smdepth = Output.Position.z;
    return Output;
}

// Pixel Shader
float4 depthPS(depthstr PSIn) : COLOR0
{
	float4 Color = float4(0.0,0.0,0.0,0.0);
	
	Color.r = PSIn.smdepth;
	float alpha = tex2D(main_map,PSIn.TexCoords).a;
	//Color.r *= alpha;//PSIn.smdepth;
	//Color.b = 1.0;//PSIn.smdepth;
Color.a = alpha;
	return Color;
	//return tex2D(main_map,PSIn.TexCoords);
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		ZWriteEnable = True;
		//Zenable = False;
		AlphaBlendEnable = True;
	//	AlphaTestEnable = True;	
		CullMode = ccw;		
		Lighting = False;
		VertexShader = compile vs_2_0 depthVS();
		PixelShader = compile ps_2_0 depthPS();
	}
}